
#ifndef WORLD
#define WORLD

#include <gtk/gtk.h>

static const gchar program_name[] = "tabble";
static const gchar default_icon_dir[] = ".";
static const gchar default_cmd_dir[] = ".";
static const gint icon_width = 48;
static const gint icon_height = 48;

enum browse_targets {bt_cmd, bt_icon};

typedef struct
{
  GString *name, *dir, *cmd, *icon;
  gint x_pos, y_pos;
} item_struct;

typedef struct
{
  struct world_info *info;
  item_struct *item;
  gint tab_pos;
  gboolean filled;
  GtkWidget *icon_image, *button, *label;
} cell_struct;

typedef struct
{
  GString *tab_name;
  GtkWidget *box_widget;
  cell_struct *cell_array;
} tab_struct;

typedef struct
{
  GtkWidget *main_window, *tabs;
  GtkWidget *edits_dialog, *edits_table, *browse_widget;
  GtkWidget *name_field, *dir_field, *cmd_field, *icon_field, *icon_image;
  GtkWidget *options_dialog, *options_table;
  GtkWidget *new_tab_dialog, *new_tab_table, *new_tab_field;
  GtkWidget *mod_tab_dialog, *mod_tab_field;
  GtkWidget *dim_dialog, *dim_x, *dim_y;
  GtkWidget *ontop_sticky_dialog, *ontop_sticky_table,
            *ontop_check, *sticky_check;

  GList *tab_list;
  gint tab_count, last_tab;
  gboolean run_again, blanks_shown;
  
  gint argc;
  gchar **argv;
  GString *conf_file, *icon_dir, *cmd_dir;
  gint max_line;
  
  gint button_spacing, icon_x_spacing, icon_y_spacing, frame_spacing;
  gint x_icons, y_icons, x_icons_new, y_icons_new;
  
  gboolean world_on_top, world_sticky, options_enabled;
  gint start_x, start_y;
  
  cell_struct *current_cell, *selected_cell;
  int browse_target;
} world_info;


#endif
